#ifndef GLWIDGET_H
#define GLWIDGET_H

#include <QGLWidget>
#include <QTimer>

#include <list>

#include "super.h"

class GLWidget: public QGLWidget
{
	Q_OBJECT

	public:
	GLWidget(QWidget* parent = NULL);
	~GLWidget();

	QSize minimumSizeHint() const;
	QSize sizeHint() const;

	public slots:
		void update();
		void timer();
		void mutationRate(int); // /100
		void addNewThing(SuperFormula* sf){mThings.push_back(sf);}
		void killAll();
		void modeRandom(){setMode(Random);}
		void modeMutate(){setMode(Mutate);}
		void modeManyKids(){setMode(ManyKids);}

	protected:
		void initializeGL();
		void paintGL();
		void resizeGL(int w, int h);
		void mousePressEvent(QMouseEvent* e);

		void killThingAt(double x, double y);
		void newThingAt(double x, double y);
		void observeAt(double x, double y);
		void childrenAt(double x, double y, int num=1);


	protected:
	QTimer* mTimer;
	std::list<SuperFormula*> mThings;
	double lastClick[2];
	double mMutationRate;
	enum ClickMode{Random,Mutate,ManyKids} mClickMode;
	void setMode(ClickMode c);
};

#endif
