#ifndef HMATH_H
#define HMATH_H

#include "Vector3.h"
#include "Matrix4.h"
// #include "glw.h"
#include <ostream>
#include <cmath>

namespace Math
{
	// const double M_PI = 3.14159265;
	// constants
	const double PI = M_PI; 
	const double TWO_PI = 2*PI;
	
	// other funcs
	double step(double a, double x); //0 if a<x, else 1
	double pulse(double a, double b, double x); //if x<a or x>b then 0, else 1
	double clamp(double a, double b, double x); //clamps x to the range [a,b]
	//double min(double a, double b);
	//double max(double a, double b);
	double abs(double a);
	int sign(double a); // 1 if a>=0 else -1
	double lerp(double a, double b, double t);
	Vector3 lerp(Vector3 a, Vector3 b, double t);
	double smoothstep(double a, double b, double x); //a smooth step from a to b
	int powi(int m, int n); // m^n
	
	using std::sin;
	using std::cos;
	using std::floor;
	using std::ceil;
	using std::pow;
	using std::log;
	using std::sqrt;
	using std::min;
	using std::max;

	double mod(double a, double b);
	double gammacorrect(double gamma, double x);
	double bias(double b, double x);
	double gain(double g, double x);
};

#endif
