#include "Matrix4.h"
#include <cstring>

Matrix4::Matrix4()
{
	//Load Identity():
	int i,j;
	for(i=0;i<4;i++) for(j=0;j<4;j++) mData[j+(4*i)]=i==j;
}

Matrix4 Matrix4::operator*(Matrix4& b)
{
	Matrix4& a = *this;	
	Matrix4 c;

	int n,m;
	for(n=0;n<4;n++)
		for(m=0;m<4;m++)
			c(n,m) = a(n,0)*b(0,m) + a(n,1)*b(1,m) + a(n,2)*b(2,m) + a(n,3)*b(3,m);
	return c;
}

Vector3 Matrix4::operator*(Vector3 b)
{
	Matrix4& a = *this;	
	Vector3 c;

	int n;
	for(n=0;n<4;n++)
		c[n] = a(n,0)*b[0] + a(n,1)*b[1] + a(n,2)*b[2] + a(n,3)*b[3];
	return c;

}

void Matrix4::setCol(int n, const Vector3& v)
{
	if(n<0||n>3)return;
	std::memcpy(&mData[n*4],const_cast<Vector3&>(v).getData(),4*sizeof(double));
	if(n!=3)mData[n*4+3]=0;
}

Vector3 Matrix4::getCol(int n)
{
	return Vector3(mData[n*4],mData[n*4+1],mData[n*4+2],mData[n*4+3]);
}

Vector3 Matrix4::getRow(int n)
{
	return Vector3(mData[n],mData[n+4],mData[n+8],mData[n+12]);
}

void Matrix4::print(std::ostream& out)
{
	int i,j;
	for(i=0;i<4;i++)
	{
		for(j=0;j<4;j++)
			out << mData[i+4*j] << " ";
		out << "\n";
	}
}
