/* A 4-d matrix class
 * BP
 */

#ifndef MATRIX4_H
#define MATRIX4_H

#include "Vector3.h"
#include <ostream>

class Matrix4
{
	protected:

	double mData[16]; //store column major order (like gl)

	public:

	Matrix4(); //loads identity

	double* getPtrToData(){return mData;}	

	/* operators */
	Matrix4 operator*(Matrix4& m);
	Vector3 operator*(Vector3 v);
	
	double& operator()(int i, int j){return mData[j*4+i];} //row i, col j

	/* Set/Get a column of this matrix */
	void setCol(int n, const Vector3& v);
	void set(int col, int row, double val){mData[row+col*4]=val;}
	
	Vector3 getCol(int n);
	Vector3 getRow(int n);

	/* Print */
	void print(std::ostream& out);
};

#endif
