#include "superview.h"

#include <GL/gl.h>

SuperView::SuperView(SuperFormula* sf, QWidget* p)
	:QGLWidget(p),mThing(sf),mTimer(NULL)
{}

SuperView::~SuperView()
{	
	if (mTimer)
		mTimer->stop();
	delete mTimer;

	delete mThing;

	makeCurrent();
}

void SuperView::initializeGL()
{
	glClearColor(1,1,1,1);
	glShadeModel(GL_SMOOTH);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
}

void
SuperView::paintGL()
{
	glClear(GL_COLOR_BUFFER_BIT);
	glLoadIdentity();

	if (mThing)
		mThing->drawPreview();
}

void
SuperView::resizeGL(int w, int h)
{
	int size = std::min(w,h);
	glViewport((w-size)/2,(h-size)/2,size,size);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(-1,+1,+1,-1);
	glMatrixMode(GL_MODELVIEW);
}

void
SuperView::update()
{
	if (mThing) mThing->update(0.01);

	repaint();
}

void
SuperView::timer()
{
	if (mTimer==NULL)
	{
		mTimer = new QTimer(this);
		connect(mTimer,SIGNAL(timeout()),this,SLOT(update()));
		mTimer->start(10);
		return;
	}
	else
	{
		if (mTimer->isActive())
			mTimer->stop();
		else
			mTimer->start(10);
	}
}
