#ifndef SUPERVIEWBOX_H
#define SUPERVIEWBOX_H

#include <QWidget>
#include <QPushButton>
#include <QSlider>
#include <QLabel>

#include "SuperView.h"

class GLWidget;
class SuperViewBox: public QWidget
{	
	Q_OBJECT
	
	public:
	SuperViewBox(SuperFormula* sf = NULL, GLWidget* glw = NULL);
	~SuperViewBox();

	private:
		SuperView* mView;
		QPushButton* mInsert;

		QSlider* mParameterSliders[9];
		QLabel* mParameterLabels[9];

		// mParams[0]--mParams[5]
		// mRotationSpeed
		// mEyeSize
		// mBorderThickness

		QPushButton *col0, *col1, *col2;

		GLWidget* mParent;

	public slots:
		void setParam0(int p){if (mView->sf()) mView->sf()->setParam(0,p);}
		void setParam1(int p){if (mView->sf()) mView->sf()->setParam(1,p);}
		void setParam2(int p){if (mView->sf()) mView->sf()->setParam(2,p);}
		void setParam3(int p){if (mView->sf()) mView->sf()->setParam(3,p);}
		void setParam4(int p){if (mView->sf()) mView->sf()->setParam(4,p);}
		void setParam5(int p){if (mView->sf()) mView->sf()->setParam(5,p);}
		void setParam6(int p){if (mView->sf()) mView->sf()->setParam(6,p);}
		void setParam7(int p){if (mView->sf()) mView->sf()->setParam(7,p);}
		void setParam8(int p){if (mView->sf()) mView->sf()->setParam(8,p);}
		void insert();
		void setColour0(){setColour(0);}
		void setColour1(){setColour(1);}
		void setColour2(){setColour(2);}

	protected:
		QSlider* makeSlider(int min, int max);
		void setColour(int i);
};

#endif
